import chart
import clr
import math
import operator
import os
import System
import time
import os.path

if ExtAPI.Context == 'Mechanical':
	clr.AddReference("Ans.UI.Toolkit") 
	clr.AddReference("Ans.UI.Toolkit.Base")
	from Ansys.UI.Toolkit import*
	import ansys
	import graphics
	import materials
	#import engineeringdata
	import units
	import Ansys.ACT
	clr.AddReference('Ansys.AAP.Mechanical')
	import Ansys.AAP.Mechanical.Tools as MechanicalTools


	# Tensor lookup table from node index in ElementTypeEnum to rst tensor.
	# For midside nodes: Give the two neighbour nodes index IN RST TENSOR
	tensorLink = {}
	tensorLink.Add(ElementTypeEnum.kHex20,{ 0:[0], 1:[1], 2:[2], 3:[3], 4:[4], 5:[5], 6:[6], 7:[7], 8:[0,1], 9:[1,2], 10:[2,3], 11:[3,0], 12:[4,5], 13:[5,6], 14:[6,7], 15:[7,4], 16:[0,4], 17:[1,5], 18:[2,6], 19:[3,7]})
	tensorLink.Add(ElementTypeEnum.kHex8,{ 0:[0], 1:[1], 2:[2], 3:[3], 4:[4], 5:[5], 6:[6], 7:[7]})
	tensorLink.Add(ElementTypeEnum.kPyramid13,{ 0:[0], 1:[1], 2:[2], 3:[3], 4:[4], 5:[0,1], 6:[1,2], 7:[2,3], 8:[3,0], 9:[0,4], 10:[1,4], 11:[2,4], 12:[3,4]})
	tensorLink.Add(ElementTypeEnum.kPyramid5,{ 0:[0], 1:[1], 2:[2], 3:[3], 4:[4]})
	tensorLink.Add(ElementTypeEnum.kQuad4, { 0:[0], 1:[1], 2:[2], 3:[3]})
	tensorLink.Add(ElementTypeEnum.kQuad8, { 0:[0], 1:[1], 2:[2], 3:[3], 4:[0,1], 5:[1,2], 6:[2,3], 7:[3,0]})
	tensorLink.Add(ElementTypeEnum.kTet10,{ 0:[0], 1:[1], 2:[2], 3:[3], 4:[0,1], 5:[1,2], 6:[2,0], 7:[0,3], 8:[1,3], 9:[2,3]})
	tensorLink.Add(ElementTypeEnum.kTet4, { 0:[0], 1:[1], 2:[2], 3:[3]})
	tensorLink.Add(ElementTypeEnum.kTri3, { 0:[0], 1:[1], 2:[2]})
	tensorLink.Add(ElementTypeEnum.kTri6, { 0:[0], 1:[1], 2:[2], 3:[0,1], 4:[1,2], 5:[2,0]})
	tensorLink.Add(ElementTypeEnum.kWedge15,{ 0:[0], 1:[1], 2:[2], 3:[4], 4:[5], 5:[6], 6:[0,1], 7:[1,2], 8:[2,0], 9:[4,5], 10:[5,6], 11:[6,4], 12:[0,4], 13:[1,5], 14:[2,6]})
	tensorLink.Add(ElementTypeEnum.kWedge6,{ 0:[0], 1:[1], 2:[2], 3:[4], 4:[5], 5:[6]})
	
